<?php

/* Reminder: always indent with 4 spaces (no tabs). */

/**
 * Base Command
 */
require_once 'BaseCommandUser.php';

/**
 * User domain object
 */
require_once 'PHPARCH/Contact.php';

/**
 * PEAR's Exception class
 */
require_once 'PEAR/Exception.php';

/**
 * DAO factory
 */
require_once 'system/DataAccess/DAO.php';

/**
 * Login command
 *
 * @copyright 2005
 * @author Tony Bibbs <Tony Bibbs <tony@geeklog.net>>
 *
 */
class PHPARCH_SearchContactsCommand extends PHPARCH_BaseCommandUser {
    /**
     * Searches contacts.
     *
     * Uses Propel and the DAO to presist an object back to the database.
     *
     * @author Tony Bibbs <tony@geeklog.net>
     * @access public
     * 
     */
    public function execute()
	{
	    $searchWords = '%' . $_POST['keywords'] . '%';
	    $searchArray = array($searchWords, $searchWords, $searchWords, $searchWords, $this->user->getAccountId());
	    $dao = PHPARCH_DAO::singleton();
	    $_REQUEST['contacts'] = $dao->find('searchContacts', $searchArray);
	    
	    return 'showResults';
	    
	}
}

?>