<?php

/* Reminder: always indent with 4 spaces (no tabs). */

/**
 * This is the data access object interface.  This sets the rules in place or any DAO 
 * implementations we may have
 *
 * @author Tony Bibbs <tony@geeklog.net>
 * @copyright 2005
 *
 */
interface PHPARCH_DAOInterface {
	const MAX_RESULTS = 500;
	public function save(&$objToSave);
	public function delete($objToDelete);
	public function deleteWithCondition($queryName, $args = null);
	public function get($objToGet); // object with only PK set
	public function find($queryName, $args=null, $page = null, $recordCount = null);
	//public function search($queryName, $strictParams, $looseParams, $looseParamTrail = null, 
	//	$page = null, $recordCount = null);
	public function search($queryName, $strictParams, $looseParams, $orderByParams = null, 
	   $logicalOperator = 'OR', $page = null, $recordCount = null);
	public function beginTransaction();
	public function rollback();
	public function commit();	
}

?>