<?php

require_once 'Data_Access/DAOFactory.php';

class NamedQueryTester {
	private $dao = null;
	private $dom = null;
	private $namedQueryFile = null;
	private $propelPeerPath = null;
	
	public function __construct($namedQueryFile, $propelPeerPath)
	{
		$this->dao = DAOFactory::getDAO();
		$this->dom = new DomDocument();
		$this->namedQueryFile = $namedQueryFile;
		$this->propelPeerPath = $propelPeerPath;
	}
	
	public function testQueries()
	{
		$this->dom->load($this->namedQueryFile);
		$xpath = new DOMXPath($this->dom);
        $queryList = $xpath->query('/named_queries/query');
        foreach ($queryList as $curQuery) {
        	$queryArgs = array();
        	$propelPeer = '';
        	$queryName = $curQuery->getAttribute('name');
        	$queryType = $curQuery->getAttribute('type');
        	// Get all the test arguments
        	if ($queryType == 'propel') {
        		$criteriaList = $xpath->query("/named_queries/query[@name='$queryName']/criteria"); 
        		foreach ($criteriaList as $curCriteria) {
        			$tmp = $curCriteria->getAttribute('testValue');
        			if (!empty($tmp)) {
        				$queryArgs[] = $curCriteria->getAttribute('testValue');
        			}
        			$propelPeer = $curCriteria->getAttribute('propelPeer');
        		}
        	} else {
        		$sqlList = $xpath->query("/named_queries/query[@name='$queryName']/sql");
        		foreach ($sqlList as $curSQL) {
        			$propelPeer = $curSQL->getAttribute('propelPeer');
        			$testValuesList = $xpath->query("/named_queries/query[@name='$queryName']/testValue");
        			foreach ($testValuesList as $testValue) {
        				$queryArgs[] = $testValue->getAttribute('value');
        			}
        		}
        	}
        	
        	// Now try running the query
        	try {
        		if (!empty($propelPeer)) {
        			require_once $this->propelPeerPath . "$propelPeer.php";
        		}
        		if (count($queryArgs) > 0) {
        			if ($queryName == 'sqlTestWithArgs') {
        				print_r($queryArgs); 
        				//exit;
        			}
        			$retval = $this->dao->find($queryName, $queryArgs);
        		} else {
        			$retval = $this->dao->find($queryName);
        		}
        	} catch (Exception $e) {
        		echo "Query $queryName failed<br/><br/>";
        		throw $e;
        	}
        	echo "Query $queryName succeeded!<br/><br/>";
        }
	}
}

?>