<html>
<head>
<title>MVCnPHP Configuration Editor</title>
</head>
<body>
<h2>MVCnPHP Configuration Editor</h2>
<p>
The following form will allow you to safely edit your MVCnPHP configuration.  By using this form you 
can be assured the resulting XML that is produced will be valid.  It is important that you are 
already familiar with the structure of the XML file format before using this form as you can do 
fairly significant damage to your application if you do not know what you are doing.
</p>
<p>
Using this form is pretty easy.  To make this form as easy as posible, we simply stub out five new 
slots that you can use for a new command or view.  Within each new or existing view and command we 
also stub out room for five new forwards.  As you might guess, to delete  view or command simply 
clear out all the data tied to it.  To add a new one simply fill in the information on one of the 
existing blanks lines.
</p>
<p>
<b>NOTE:</b>Please realize that if you configure your MVCnPHP configuration below to allow using
this user interface, you have essentially allowed this file to be edited by anyone.  During
development this isn't so bad but it is important that you turn off the user interface before 
deploying your application to production.  If you don't do this, others familiar with MVCnPHP could
edit your configuration without your knowledge.
</p>
<p>
<form action="index.php" method="POST">
<?php echo $this->elements['cmd']->toHtml();?>
<table>
    <tr>
        <th align="right">MVC Configuration File:</th><td><?php echo htmlspecialchars($t->configFile);?></td>
    </tr>
    <tr>
        <th align="right">Compile Configuration:</th><td><?php echo $this->elements['compile']->toHtml();?></td>
    </tr>
    <tr>
        <th align="right">Enable Configuration User Interface:</th><td><?php echo $this->elements['ui']->toHtml();?></td>
    </tr>
</table>
</p>
<table>
    <?php if ($this->options['strict'] || (isset($t) && method_exists($t,'numViews'))) if ($t->numViews()) { ?>
    <tr><th>Views</th></tr>
    <?php if ($this->options['strict'] || (is_array($t->viewArray)  || is_object($t->viewArray))) foreach($t->viewArray as $key => $curView) {?>
    <tr>
        <td>
            <table>                
                <tr><th align="right">Display Name:</th> <input type="text" size="50" name="displayName_<?php echo htmlspecialchars($key);?>" value="<?php echo htmlspecialchars($key);?>" /></tr>
                <tr><th align="right">Class Name:</th> <input type="text" size="50" name="className_<?php echo htmlspecialchars($key);?>" value="<?php if ($this->options['strict'] || (isset($t) && method_exists($t,'getClassName'))) echo htmlspecialchars($t->getClassName($curView));?>" /><tr />
                <tr><th align="right">Parent Class:</th> <input type="text" size="50" name="parentName_<?php echo htmlspecialchars($key);?>" value="<?php if ($this->options['strict'] || (isset($t) && method_exists($t,'getParentName'))) echo htmlspecialchars($t->getParentName($curView));?>" /></tr>
            </table>
        </td>
    </tr>
    <?php if ($this->options['strict'] || (isset($t) && method_exists($t,'loadForwards'))) echo htmlspecialchars($t->loadForwards($curView));?>    
    <tr>
        <td>
            <table cellpadding="0" cellspacing="4">
                <tr>                    
                    <th align="left">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Forward Name</th>
                    <th align="left">Forward Type</th>
                    <th align="left">Target Display Name</th>                    
                </tr>
                <?php if ($this->options['strict'] || (is_array($t->forwards)  || is_object($t->forwards))) foreach($t->forwards as $forwardKey => $curForward) {?>
                <tr>
                    <td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
                        <input type="text" size="50" name="forwardName_<?php echo htmlspecialchars($key);?>_<?php echo htmlspecialchars($forwardKey);?>" value="<?php echo htmlspecialchars($forwardKey);?>" />
                    </td>                    
                    <td>
                        <select name="forwardType_<?php echo htmlspecialchars($key);?>_<?php echo htmlspecialchars($forwardKey);?>">
                            <option value="">--Select Type--</option>
                            <option value="command<?php if ($this->options['strict'] || (isset($t) && method_exists($t,'checkSelection'))) echo $t->checkSelection($curForward,"command");?>">Command</option>
                            <option value="redirect<?php if ($this->options['strict'] || (isset($t) && method_exists($t,'checkSelection'))) echo $t->checkSelection($curForward,"redirect");?>">Redirect</option>
                            <option value="view<?php if ($this->options['strict'] || (isset($t) && method_exists($t,'checkSelection'))) echo $t->checkSelection($curForward,"view");?>">View</option>                            
                        </select>
                    </td>
                    <td><input type="text" size="50" name="forwardDisplayName_<?php echo htmlspecialchars($key);?>_<?php echo htmlspecialchars($forwardKey);?>" value="<?php if ($this->options['strict'] || (isset($t) && method_exists($t,'getForwardTargetyName'))) echo htmlspecialchars($t->getForwardTargetyName($curForward));?>" /><td>
                </tr>                
                <?php }?>
                <tr>
                    <td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
                        <input type="text" size="50" name="forwardName_<?php echo htmlspecialchars($key);?>_new1" />
                    </td>
                    <td>
                        <select name="forwardType_<?php echo htmlspecialchars($key);?>_new1">
                            <option value="">--Select Type--</option>
                            <option value="command">Command</option>
                            <option value="redirect">Redirect</option>
                            <option value="view">View</option>                            
                        </select>
                    </td>
                    <td><input type="text" size="50" name="forwardDisplayName_<?php echo htmlspecialchars($key);?>_new1" /><td>
                </tr>
                <tr>
                    <td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
                        <input type="text" size="50" name="forwardName_<?php echo htmlspecialchars($key);?>_new2" />
                    </td>
                    <td>
                        <select name="forwardType_<?php echo htmlspecialchars($key);?>_new2">
                            <option value="">--Select Type--</option>
                            <option value="command">Command</option>
                            <option value="redirect">Redirect</option>
                            <option value="view">View</option>                            
                        </select>
                    </td>
                    <td><input type="text" size="50" name="forwardDisplayName_<?php echo htmlspecialchars($key);?>_new2" /><td>
                </tr>
                <tr>
                    <td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
                        <input type="text" size="50" name="forwardName_<?php echo htmlspecialchars($key);?>_new3" />
                    </td>
                    <td>
                        <select name="forwardType_<?php echo htmlspecialchars($key);?>_new3">
                            <option value="">--Select Type--</option>
                            <option value="command">Command</option>
                            <option value="redirect">Redirect</option>
                            <option value="view">View</option>                            
                        </select>
                    </td>
                    <td><input type="text" size="50" name="forwardDisplayName_<?php echo htmlspecialchars($key);?>_new3" /><td>
                </tr>                
                    
            </table>
        </td>
    </tr>
    <tr>
        <td><hr /></td>
    </tr>
    <?php }?>
    <?php }?>    
    <?php if ($this->options['strict'] || (isset($t) && method_exists($t,'numCommands'))) if ($t->numCommands()) { ?>
    <?php }?>
    <tr>
        <td><b>Display Name:</b> <?php echo $this->elements['displayName_new1']->toHtml();?></td>
        <td><b>Class Name:</b> <?php echo $this->elements['className_new1']->toHtml();?></td>
    </tr>
   <tr>
        <td colspan="2">
            <table width="100%" cellpadding="0" cellspacing="0">
                <tr>                    
                    <th align="left">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Forward Name</th>
                    <th align="left">Forward Type</th>
                    <th align="left">Target Display Name</th>                    
                </tr>
                <tr>
                    <td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
                        <input type="text" size="50" name="forwardName_new1_new1" />
                    </td>                    
                    <td>
                        <?php echo $this->elements['forwardType_new1_new1']->toHtml();?>
                    </td>
                    <td><input type="text" size="50" name="forwardDisplayName_new1_new1" value="<?php if ($this->options['strict'] || (isset($t) && method_exists($t,'getForwardTargetyName'))) echo htmlspecialchars($t->getForwardTargetyName($t->curForward));?>" /><td>
                </tr>           
                <tr>
                    <td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
                        <input type="text" size="50" name="forwardName_new1_new2" />
                    </td>                    
                    <td>
                        <?php echo $this->elements['forwardType_new1_new2']->toHtml();?>
                    </td>
                    <td><input type="text" size="50" name="forwardDisplayName_new1_new2" value="<?php if ($this->options['strict'] || (isset($t) && method_exists($t,'getForwardTargetyName'))) echo htmlspecialchars($t->getForwardTargetyName($t->curForward));?>" /><td>
                </tr>             
                <tr>
                    <td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
                        <input type="text" size="50" name="forwardName_new1_new3" />
                    </td>                    
                    <td>
                        <?php echo $this->elements['forwardType_new1_new3']->toHtml();?>
                    </td>
                    <td><input type="text" size="50" name="forwardDisplayName_new1_new3" value="<?php if ($this->options['strict'] || (isset($t) && method_exists($t,'getForwardTargetyName'))) echo htmlspecialchars($t->getForwardTargetyName($t->curForward));?>" /><td>
                </tr>                  
            </table>
        </td>
    </tr>
     <tr>
        <td align="center" colspan="2"><input type="submit" value="Save Configuration" /></td>
    </tr>    
</table>
</form>
</body>
</html>