<?php 

require_once 'propel/om/BaseObject.php';

require_once 'propel/om/Persistent.php';
 

include_once 'propel/util/Criteria.php';
 

// (on-demand) include_once 'bookstore/Book.php';
// (on-demand) include_once 'bookstore/BookPeer.php';

include_once 'bookstore/ReviewPeer.php';

/**
 * Base class that represents a row from the 'review' table.
 *
 * Book Review *
 * This class was autogenerated by Propel on:
 *
 * [02/20/05 19:50:56]
 *
 * You should not use this class directly.  It should not even be
 * extended; all references should be to Review class. 
 * 
 * @package bookstore 
 */
abstract class BaseReview extends BaseObject implements Persistent {
    
    /** 
     * The Peer class.
     * Instance provides a convenient way of calling static methods on a class
     * that calling code may not be able to identify.
     * @var ReviewPeer
     */
    protected static $peer;

    /**
     * The value for the review_id field.
     * @var int      
     */
    protected $review_id;    

    /**
     * The value for the reviewed_by field.
     * @var string      
     */
    protected $reviewed_by;    

    /**
     * The value for the review_date field.
     * @var int      
     */
    protected $review_date;    

    /**
     * The value for the recommended field.
     * @var boolean      
     */
    protected $recommended;    

    /**
     * The value for the book_id field.
     * @var int      
     */
    protected $book_id;    
  
    /**
     * Get the ReviewId column value.
     * Author Id     * @return int      
     */
    public function getReviewId()
    {
        return $this->review_id;
    }


    /**
     * Set the value of `review_id` column.      
     * Author Id     * @param int $v new value
     * @return void
     *  
     */
    public function setReviewId($v)
    {
        if ($this->review_id !== $v) {
            $this->review_id = $v;
            $this->modifiedColumns[] = ReviewPeer::REVIEW_ID;
        }
                
    }

  
    /**
     * Get the ReviewedBy column value.
     * Reviewer Name     * @return string      
     */
    public function getReviewedBy()
    {
        return $this->reviewed_by;
    }


    /**
     * Set the value of `reviewed_by` column.      
     * Reviewer Name     * @param string $v new value
     * @return void
     *  
     */
    public function setReviewedBy($v)
    {
        if ($this->reviewed_by !== $v) {
            $this->reviewed_by = $v;
            $this->modifiedColumns[] = ReviewPeer::REVIEWED_BY;
        }
                
    }


    /**
     * Get the [optionally formatted] `review_date` column value.
     * Date of Review     * @param string $format The date/time format string (either date()-style or strftime()-style).
     *                            If format is NULL, then the integer unix timestamp will be returned.
     * @return mixed Formatted date/time value as string or integer unix timestamp (if format is NULL).
     * @throws PropelException - if unable to convert the date/time to timestamp.
     */
    public function getReviewDate($format = '%x')
    {
        if ($this->review_date === null || $this->review_date === '') {
            return null;
        } elseif (!is_int($this->review_date)) {
            // a non-timestamp value was set externally, so we convert it
            $ts = strtotime($this->review_date);
            if ($ts === -1) {
                throw new PropelException("Unable to parse value of review_date as date/time value: " . var_export($this->review_date, true));
            }
        } else {
            $ts = $this->review_date;
        }
        if ($format === null) {
            return $ts;
        } elseif (strpos($format, '%') !== false) {
            return strftime($format, $ts);
        } else {
            return date($format, $ts);
        }
    }


    /**
     * Set the value of `review_date` column.      
     * Date of Review     * @param int $v new value
     * @return void
     * @throws PropelException - If passed [not-null] date/time is in an invalid format. 
     */
    public function setReviewDate($v)
    {
        if ($this->review_date !== $v) {
            if ($v !== null && !is_int($v)) {
                $ts = strtotime($v);
                if ($ts === -1) {
                    throw new PropelException("Unable to parse date/time value for review_date from input: " . var_export($v, true));
                }
            } else {
                $ts = $v;
            }
            $this->review_date = $ts;
            $this->modifiedColumns[] = ReviewPeer::REVIEW_DATE;
        }
        
    }

  
    /**
     * Get the Recommended column value.
     * Does reviewer recommend book?     * @return boolean      
     */
    public function getRecommended()
    {
        return $this->recommended;
    }


    /**
     * Set the value of `recommended` column.      
     * Does reviewer recommend book?     * @param boolean $v new value
     * @return void
     *  
     */
    public function setRecommended($v)
    {
        if ($this->recommended !== $v) {
            $this->recommended = $v;
            $this->modifiedColumns[] = ReviewPeer::RECOMMENDED;
        }
                
    }

  
    /**
     * Get the BookId column value.
     * Book ID for this review     * @return int      
     */
    public function getBookId()
    {
        return $this->book_id;
    }


    /**
     * Set the value of `book_id` column.      
     * Book ID for this review     * @param int $v new value
     * @return void
     * @throws PropelException 
     */
    public function setBookId($v)
    {
        if ($this->book_id !== $v) {
            $this->book_id = $v;
            $this->modifiedColumns[] = ReviewPeer::BOOK_ID;
        }
            
        if ($this->aBook !== null && $this->aBook->getBookId() !== $v) {
            $this->aBook = null;
        }
            
    }


    
    /**
     * Hydrates (populates) the object variables with values from the database resultset.
     *
     * An offset (1-based "start column") is specified so that objects can be hydrated
     * with a subset of the columns in the resultset rows.  This is needed, for example,
     * for results of JOIN queries where the resultset row includes columns from two or
     * more tables.
     *
     * @param ResultSet $rs The ResultSet class with cursor advanced to desired record pos.
     * @param int $startcol 1-based offset column which indicates which restultset column to start with.
     * @return void
     * @throws PropelException  - Any caught Exception will be rewrapped as a PropelException.
     */
    public function hydrate(ResultSet $rs, $startcol = 1)
    {
        try {
            $this->review_id = $rs->getInt($startcol + 0);                    
            $this->reviewed_by = $rs->getString($startcol + 1);                    
            $this->review_date = $rs->getDate($startcol + 2, null);
            $this->recommended = $rs->getBoolean($startcol + 3);                    
            $this->book_id = $rs->getInt($startcol + 4);                    
             
            $this->resetModified();
            $this->setNew(false);
        
        } catch (Exception $e) {
            throw new PropelException("Error populating object", $e);
        }        
    
    }
    
    /**
     * Builds a Criteria object containing the primary key for this object.
     *
     * Unlike buildCriteria() this method includes the primary key values regardless
     * of whether or not they have been modified.
     * 
     * @return Criteria The Criteria object containing value(s) for primary key(s).
     */
    public function buildPkeyCriteria()
    {        
        $criteria = new Criteria(ReviewPeer::DATABASE_NAME);
        $criteria->add(ReviewPeer::REVIEW_ID, $this->review_id);
        return $criteria;            
    }
    
    /**
     * Build a Criteria object containing the values of all modified columns in this object.
     *
     * @return Criteria The Criteria object containing all modified values.
     */
    public function buildCriteria()
    {        
        $criteria = new Criteria(ReviewPeer::DATABASE_NAME);
        if ($this->isColumnModified(ReviewPeer::REVIEW_ID)) $criteria->add(ReviewPeer::REVIEW_ID, $this->review_id);
        if ($this->isColumnModified(ReviewPeer::REVIEWED_BY)) $criteria->add(ReviewPeer::REVIEWED_BY, $this->reviewed_by);
        if ($this->isColumnModified(ReviewPeer::REVIEW_DATE)) $criteria->add(ReviewPeer::REVIEW_DATE, $this->review_date);
        if ($this->isColumnModified(ReviewPeer::RECOMMENDED)) $criteria->add(ReviewPeer::RECOMMENDED, $this->recommended);
        if ($this->isColumnModified(ReviewPeer::BOOK_ID)) $criteria->add(ReviewPeer::BOOK_ID, $this->book_id);
        return $criteria;            
    }
    
    

    /**
     * @var Book      
     */
    protected $aBook;

    /**
     * Declares an association between this object and a Book object
     *
     * @param Book $v
     * @return void
     * @throws PropelException
     */
    public function setBook($v)
    {
            
        if ($v === null) {
            $this->setBookId(NULL);
        } else {
            $this->setBookId($v->getBookId());
        }
   
        $this->aBook = $v;
    }


    /**
     * Get the associated Book object
     *
     * @param Connection Optional Connection object.
     * @return Book The associated Book object.
     * @throws PropelException
     */
    public function getBook($con = null)
    {
        // include the Peer class
        include_once 'bookstore/BookPeer.php';

        if ($this->aBook === null && ($this->book_id !== null)) {
    
            $this->aBook = BookPeer::retrieveByPK($this->book_id, $con);
    
            /* The following can be used instead of the line above to
               guarantee the related object contains a reference
               to this object, but this level of coupling
               may be undesirable in many circumstances.
               As it can lead to a db query with many results that may
               never be used.
               $obj = BookPeer::retrieveByPK($this->book_id, $con);
               $obj->addReviews($this);
             */
        }
        return $this->aBook;
    }

    /**
     * Provides convenient way to set a relationship based on a
     * key.  e.g.
     * <code>$bar->setFooKey($foo->getPrimaryKey())</code>
     *
 
     * @return void
     * @throws PropelException
     */
    public function setBookKey($key)
    {

        $this->setBookId( (int) $key);            
        
    }



 
    /**
     * Removes this object from datastore and sets delete attribute.
     * 
     * @param Connection $con
     * @return void
     * @throws PropelException
     * @see BaseObject::setDeleted()
     * @see BaseObject::isDeleted()
     */
    public function delete($con = null)
    {    
        if ($this->isDeleted()) {
            throw new PropelException("This object has already been deleted.");
        }
        
        if ($con === null)
            $con = Propel::getConnection(ReviewPeer::DATABASE_NAME);

        try {
            $con->begin();
            ReviewPeer::doDelete($this, $con);
            $this->setDeleted(true);
            $con->commit();
        } catch (PropelException $e) {
            $con->rollback();
            throw $e;
        }
    }
    

    /**
     * flag to prevent endless save loop, if this object is referenced
     * by another object which falls in this transaction.
     * @var boolean
     */
    private $alreadyInSave = false;

    /**
     * Stores the object in the database.  If the object is new,
     * it inserts it; otherwise an update is performed.  This method
     * wraps the doSave() worker method in a transaction.
     *
     * @param Connection $con
     * @return void
     * @throws PropelException
     */
    public function save($con = null)
    {
        if ($this->isDeleted()) {
            throw new PropelException("You cannot save an object that has been deleted.");
        }
        
        if ($con === null)
            $con = Propel::getConnection(ReviewPeer::DATABASE_NAME);

        try {
            $con->begin();
            $this->doSave($con);            
            $con->commit();
        } catch (PropelException $e) {
            $con->rollback();
            throw $e;
        }
    }
  
    /**
     * Stores the object in the database.  If the object is new,
     * it inserts it; otherwise an update is performed.
     *
     * @param Connection $con
     * @return void
     * @throws PropelException
     */
		protected function doSave($con)    { 
        
     
        if (!$this->alreadyInSave) {
            $this->alreadyInSave = true;

            // We call the save method on the following object(s) if they
            // were passed to this object by their coresponding set
            // method.  This object relates to these object(s) by a
            // foreign key reference.
 
            if ($this->aBook !== null) {
                if ($this->aBook->isModified()) $this->aBook->save($con);
                $this->setBook($this->aBook);
            }

            // If this object has been modified, then save it to the database.
            if ($this->isModified()) {
                if ($this->isNew()) {
                    $pk = ReviewPeer::doInsert($this, $con);
					$this->setReviewId( $pk );  //[IMV] update autoincrement primary key
                    $this->setNew(false);
                } else {
                    ReviewPeer::doUpdate($this, $con);
                }            
                $this->resetModified(); // [HL] After being saved an object is no longer 'modified'
            }

            $this->alreadyInSave = false;
        }
    }

    /**
     * Validates the objects modified field values.
     * This includes all objects related to this table.
     *
     * @return mixed <code>true</code> if all columns pass validation
     *              or an array of <code>ValidationFailed</code> objects for columns that fail.
     */
    public function validate()
    {
        return $this->doValidate();
    }

    /**
     * flag to prevent endless validation loop, if this object is referenced
     * by another object which falls in this transaction.
     * @var boolean
     */
    protected $alreadyInValidation = false;
  
    /**
     * This function performs the validation work for complex object models.
     * 
     * In addition to checking the current object, all related objects will
     * also be validated.  If all pass then <code>true</code> is returned; otherwise
     * an aggreagated array of ValidationFailed objects will be returned.
     *
     * @return mixed <code>true</code> if all validations pass; array of <code>ValidationFailed</code> objets otherwise.
     */
    protected function doValidate()
    {
        if (! $this->alreadyInValidation) {
            $this->alreadyInValidation = true;
            $retval = null;
      
            $failureMap = array();      
      
            // We call the validate method on the following object(s) if they
            // were passed to this object by their coresponding set
            // method.  This object relates to these object(s) by a
            // foreign key reference.
            if ($this->aBook !== null) {
                if (($retval = $this->aBook->validate()) !== true) {
                    $failureMap = array_merge($failureMap, $retval);
                }
            }

            if (($retval = ReviewPeer::doValidate($this)) !== true) {
                $failureMap = array_merge($failureMap, $retval);
            }
      
      
            $this->alreadyInValidation = false;
        }
    
        return (!empty($failureMap) ? $failureMap : true);
    }
  

    /**
     * Set the PrimaryKey.
     *
     * @param mixed review_id Primary key.
     * @return void
     * @throws PropelException     */
    public function setPrimaryKey($key) 
    {        
        $this->setReviewId($key);
    }
    

    /**
     * Returns an id that differentiates this object from others
     * of its class.
     * @return int 
     */
    public function getPrimaryKey()
    {

        return $this->getReviewId();

    }

    
    /**
     * Makes a copy of this object that will be inserted as a new row in table when saved.
     * It creates a new object filling in the simple attributes, but skipping any primary
     * keys that are defined for the table.
     *  
     * If desired, this method can also make copies of all associated (fkey referrers)
     * objects.
     *
     * @param boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
     *  
     * @return Review Clone of current object.
     * @throws PropelException
     */
    public function copy($deepCopy = false) 
    {
        $copyObj = new Review();
        $copyObj->setReviewedBy($this->reviewed_by);
        $copyObj->setReviewDate($this->review_date);
        $copyObj->setRecommended($this->recommended);
        $copyObj->setBookId($this->book_id);
        
        $copyObj->setNew(true);
        
        $copyObj->setReviewId(NULL); // this is a pkey column, so set to default value

        return $copyObj;
    }
        

    /**
     * returns a peer instance associated with this om.  Since Peer classes    
     * are not to have any instance attributes, this method returns the
     * same instance for all member of this class. The method could therefore
     * be static, but this would prevent one from overriding the behavior.
     * @return ReviewPeer
     */
    public function getPeer()
    {
        if (self::$peer === null) {
            self::$peer = new ReviewPeer();
        }
        return self::$peer;
    }

}