<?php
require_once 'propel/util/BasePeer.php';

// The object class -- needed for instanceof checks in this class.
// actual class may be a subclass -- as returned by ReviewPeer::getOMClass()
include_once 'bookstore/Review.php';
    
include_once 'bookstore/Book.php';
include_once 'bookstore/BookPeer.php';

/**
 * Base static class for performing query and update operations on the 'review' table.
 *
 * Book Review *
 * This class was autogenerated by Propel on:
 *
 * [02/20/05 19:50:56]
 *
 * @package bookstore 
 */
abstract class BaseReviewPeer
{

    /** the default database name for this class */
    const DATABASE_NAME = "bookstore";

    /** the table name for this class */
    const TABLE_NAME = "review";

 
    /** the column name for the REVIEW_ID field */
    const REVIEW_ID = "review.REVIEW_ID";
 
    /** the column name for the REVIEWED_BY field */
    const REVIEWED_BY = "review.REVIEWED_BY";
 
    /** the column name for the REVIEW_DATE field */
    const REVIEW_DATE = "review.REVIEW_DATE";
 
    /** the column name for the RECOMMENDED field */
    const RECOMMENDED = "review.RECOMMENDED";
 
    /** the column name for the BOOK_ID field */
    const BOOK_ID = "review.BOOK_ID";

    

    /** number of columns for this peer */
    public static $numColumns = 5;
    
    /** A class that can be returned by this peer. */
    const CLASS_DEFAULT = "bookstore.Review";

    /** The PHP to DB Name Mapping */
    private static $phpNameMap = null;

    /**
     * @return MapBuilder the map builder for this peer
     * @throws PropelException Any exceptions caught during processing will be
     *         rethrown wrapped into a PropelException.
     */
    public static function getMapBuilder()        
    {
        include_once 'bookstore/map/ReviewMapBuilder.php';
        return BasePeer::getMapBuilder(ReviewMapBuilder::CLASS_NAME);
    }

    /**
     * Gets a map (hash) of PHP names to DB column names.
     *
     * @return array The PHP to DB name map for this peer
     * @throws PropelException Any exceptions caught during processing will be
     *         rethrown wrapped into a PropelException.
     * @todo Consider having template build the array rather than doing it at runtime.
     */
    public static function getPhpNameMap()
    {
        if (self::$phpNameMap === null) {
            $map = ReviewPeer::getTableMap();
            $columns = $map->getColumns();
            $nameMap = array();
            foreach ($columns as $column) {
                $nameMap[$column->getPhpName()] = $column->getColumnName();
            }
            self::$phpNameMap = $nameMap;
        }
        return self::$phpNameMap;
    }
    
    /**
     * Convenience method which changes table.column to alias.column.
     *
     * Using this method you can maintain SQL abstraction while using column aliases.
     * <code>
     *        $c->addAlias("alias1", TablePeer::TABLE_NAME);
     *        $c->addJoin(TablePeer::alias("alias1", TablePeer::PRIMARY_KEY_COLUMN), TablePeer::PRIMARY_KEY_COLUMN);
     * </code>
     * @param string $alias The alias for the current table.
     * @param string $column The column name for current table. (i.e. ReviewPeer::COLUMN_NAME).
     * @return string
     */
    public static function alias($alias, $column)
    {
        return $alias . substr($column, strlen(self::TABLE_NAME));
    }
    
    /**
     * Add all the columns needed to create a new object.
     * 
     * Note: any columns that were marked with lazyLoad="true" in the
     * XML schema will not be added to the select list and only loaded
     * on demand.
     *
     * @param criteria object containing the columns to add.
     * @throws PropelException Any exceptions caught during processing will be
     *         rethrown wrapped into a PropelException.
     */
    public static function addSelectColumns(Criteria $criteria)
    {
        $criteria->addSelectColumn(self::REVIEW_ID);
        $criteria->addSelectColumn(self::REVIEWED_BY);
        $criteria->addSelectColumn(self::REVIEW_DATE);
        $criteria->addSelectColumn(self::RECOMMENDED);
        $criteria->addSelectColumn(self::BOOK_ID);
    }

    /**
     * Populates an object from a resultset row starting
     * from a specified start column.  This is done so that you can select
     * other rows than just those needed for this object.  You may
     * for example want to create two objects from the same row.
     *
     * @param ResultSet $rs The ResultSet to use for setting values.
     * @param Review $obj The object to populate.
     * @param int $startcol The column to start with (1 is first column).     
     * @return void
     * @throws PropelException Any exceptions caught during processing will be
     *         rethrown wrapped into a PropelException.
     * @deprecated This method has been deprecated in favor of the more flexible
     *              Review->hydrate() method.
     *              This method is planned for removal in Propel 1.1.
     * @see Review::hydrate()
     */
    public static function populateObject(ResultSet $rs,Review $obj, $startcol = 1)
    {        
        $obj->hydrate($rs, $startcol);        
    }
    
    const COUNT = "COUNT(review.REVIEW_ID)";
    const COUNT_DISTINCT = "COUNT(DISTINCT review.REVIEW_ID)";
  
    /**
     * Returns the number of rows matching criteria.
     *
     * @param Criteria $criteria
     * @param boolean $distinct Whether to select only distinct columns.
     * @param Connection $con
     * @return int Number of matching rows.
     */
    function doCount(Criteria $criteria, $distinct = false, $con = null)
    {   
        // we're going to modify criteria, so copy it first
        $criteria = clone $criteria;
        
        // clear out anything that might confuse the ORDER BY clause
        $criteria->clearSelectColumns()->clearOrderByColumns();
        if ($distinct || in_array(Criteria::DISTINCT, $criteria->getSelectModifiers())) {
            $criteria->addSelectColumn(ReviewPeer::COUNT_DISTINCT);
        } else {
            $criteria->addSelectColumn(ReviewPeer::COUNT);    
        }
        
        $rs = ReviewPeer::doSelectRS($criteria, $con);        
        if ($rs->next()) {
            return $rs->getInt(1);
        } else {
            // no rows returned; we infer that means 0 matches.
            return 0;
        }
    }
  
    /**
     * Method to select one object from the DB.
     *
     * @param Criteria $criteria object used to create the SELECT statement.
     * @param Connection $con
     * @return Review     * @throws PropelException Any exceptions caught during processing will be
     *         rethrown wrapped into a PropelException.
     */
    public static function doSelectOne(Criteria $criteria, $con = null)
    {
        $critcopy = clone $criteria;
        $critcopy->setLimit(1);
        $objects = ReviewPeer::doSelect($critcopy, $con);
        if ($objects) {
            return $objects[0];
        }
        return null;
    }

    /**
     * Method to do selects.
     *
     * @param Criteria $criteria The Criteria object used to build the SELECT statement.
     * @param Connection $con
     * @return array Array of selected Objects
     * @throws PropelException Any exceptions caught during processing will be
     *         rethrown wrapped into a PropelException.
     */
    public static function doSelect(Criteria $criteria, $con = null)
    {
        return ReviewPeer::populateObjects(ReviewPeer::doSelectRS($criteria, $con));
    }
    
    /**
     * Prepares the Criteria object and uses the parent doSelect()
     * method to get a ResultSet.
     * 
     * Use this method directly if you want to just get the resultset
     * (instead of an array of objects).
     *
     * @param Criteria $criteria The Criteria object used to build the SELECT statement.
     * @param Connection $con the connection to use
     * @throws PropelException Any exceptions caught during processing will be
     *         rethrown wrapped into a PropelException.
     * @return ResultSet The resultset object with numerically-indexed fields.
     * @see BasePeer::doSelect()
     */
    public static function doSelectRS(Criteria $criteria, $con = null)
    {
        if ($con === null) {
            $con = Propel::getConnection(self::DATABASE_NAME);
        }                

        if (!$criteria->getSelectColumns()) {
            ReviewPeer::addSelectColumns($criteria);
        }
    
        // Set the correct dbName
        $criteria->setDbName(self::DATABASE_NAME);
        
        // BasePeer returns a Creole ResultSet, set to return
        // rows indexed numerically.           
        return BasePeer::doSelect($criteria, $con);
    }

    /**
     * The returned array will contain objects of the default type or
     * objects that inherit from the default.
     *
     * @throws PropelException Any exceptions caught during processing will be
     *         rethrown wrapped into a PropelException.
     */
    public static function populateObjects(ResultSet $rs)
    {
        $results = array();
        
        // set the class once to avoid overhead in the loop
        $cls = ReviewPeer::getOMClass();
        $cls = Propel::import($cls);

        // populate the object(s)
        while($rs->next()) {
            
            $obj = new $cls();
            $obj->hydrate($rs);
            $results[] = $obj;
        }
        return $results;
    }



    /**
     * The class that the Peer will make instances of.
     * If the BO is abstract then you must implement this method
     * in the BO.
     *
     * @throws PropelException Any exceptions caught during processing will be
     *         rethrown wrapped into a PropelException.
     */
    public static function getOMClass()
    { 
        return self::CLASS_DEFAULT;
         
    }
 

    /**
     * Method perform an INSERT on the database, given a Review or Criteria object.
     *
     * @param mixed $values Criteria or Review object containing data that is used to create the INSERT statement.
     * @param Connection $con the connection to use
     * @return mixed The new primary key.
     * @throws PropelException Any exceptions caught during processing will be
     *         rethrown wrapped into a PropelException.
     */
    public static function doInsert($values, $con = null)
    {        
        if ($con === null)
            $con = Propel::getConnection(self::DATABASE_NAME);

        if ($values instanceof Criteria) {
            $criteria = $values;
        } else {
            $criteria = $values->buildCriteria();
        }
        
        
        $criteria->remove(self::REVIEW_ID); // remove pkey col since this table uses auto-increment
         
        
        // Set the correct dbName
        $criteria->setDbName(self::DATABASE_NAME);
        
        try {
            // use transaction because $criteria could contain info
            // for more than one table (I guess, conceivably)
            $con->begin();
            $pk = BasePeer::doInsert($criteria, $con);
            $con->commit();
        } catch(PropelException $e) {
            $con->rollback();
            throw $e;
        }
        
        return $pk;        
    }

    /**
     * Method perform an UPDATE on the database, given a Review or Criteria object.
     *
     * @param mixed $values Criteria or Review object containing data that is used to create the UPDATE statement.
     * @param Connection $con The connection to use (specify Connection object to exert more control over transactions).
     * @return void
     * @throws PropelException Any exceptions caught during processing will be
     *         rethrown wrapped into a PropelException.
     */
    public static function doUpdate($values, $con = null)
    {            
        if ($con === null) {
            $con = Propel::getConnection(self::DATABASE_NAME);
        }
        
        $selectCriteria = new Criteria(self::DATABASE_NAME);
                
        if ($values instanceof Criteria) {
            $criteria = $values;
            $selectCriteria->put(self::REVIEW_ID, $criteria->remove(self::REVIEW_ID));
 
        } else { // $values is Review object
            $criteria = $values->buildCriteria(); // gets full criteria
            $selectCriteria = $values->buildPkeyCriteria(); // gets criteria w/ primary key(s)            
        }    
        
        // set the correct dbName
        $criteria->setDbName(self::DATABASE_NAME);
        
        BasePeer::doUpdate($selectCriteria, $criteria, $con);        
    }   
    
    /**
     * Method perform a DELETE on the database, given a Review or Criteria object OR a primary key value.
     *
     * @param mixed $values Criteria or Review object or primary key which is used to create the DELETE statement 
     * @param Connection $con the connection to use
     * @return void
     * @throws PropelException Any exceptions caught during processing will be
     *         rethrown wrapped into a PropelException.
     */
     public static function doDelete($values, $con = null)
     {        
        if ($con === null)
            $con = Propel::getConnection(self::DATABASE_NAME);

        if ($values instanceof Criteria) {
            $criteria = $values;
        } elseif ($values instanceof Review) {
            $criteria = $values->buildPkeyCriteria();
        } else {
            // it must be the primary key
            $criteria = new Criteria(self::DATABASE_NAME);
            $criteria->add(self::REVIEW_ID, $values);
        }
             
        // Set the correct dbName
        $criteria->setDbName(self::DATABASE_NAME);
        
        try {
            // use transaction because $criteria could contain info
            // for more than one table or we could emulating ON DELETE CASCADE, etc.
            $con->begin();
             
            BasePeer::doDelete($criteria, $con);
            $con->commit();
        } catch (PropelException $e) {
            $con->rollback();
            throw $e;
        }        
    }    

    
    /**
     * Validates all modified columns of given Review object.
     *
     * NOTICE: This does not apply to primary or foreign keys for now.
     *
     * @param Review $obj The object to validate.
     * @return mixed TRUE if all columns are valid or the error message of the first invalid column.
     */
    public static function doValidate(Review $obj)
    {        
        $columns = array();
        if ($obj->isNew() || $obj->isColumnModified(self::REVIEWED_BY))
            $columns[self::REVIEWED_BY] = $obj->getReviewedBy();
        return BasePeer::doValidate(self::DATABASE_NAME, self::TABLE_NAME, $columns);
    }
      


    /**
     * Retrieve a single object by pkey.
     *
     * @param mixed $pk the primary key.
     * @param Connection $con the connection to use
     * @throws PropelException Any exceptions caught during processing will be
     *         rethrown wrapped into a PropelException.
     */
    public static function retrieveByPK($pk, $con = null)
    {        
        if ($con === null) {
            $con = Propel::getConnection(self::DATABASE_NAME);
        }
        
        $criteria = new Criteria(self::DATABASE_NAME);
        $criteria->add(self::REVIEW_ID, $pk);
                        
        $v = ReviewPeer::doSelect($criteria, $con);
        if (count($v) !== 1) {
            throw new PropelException("Failed to select one and only one row.");
        } else {
            return $v[0];
        }
    }

    /**
     * Retrieve multiple objects by pkey.
     *
     * @param array $pks List of primary keys
     * @param Connection $con the connection to use
     * @throws PropelException Any exceptions caught during processing will be
     *         rethrown wrapped into a PropelException.
     */
    public static function retrieveByPKs($pks, $con = null)
    {
        if ($con === null) {
            $con = Propel::getConnection(self::DATABASE_NAME);
        }
        
        $objs = null;
        if (empty($pks)) {
            $objs = array();
        } else {
            $criteria = new Criteria();
            $criteria->add(self::REVIEW_ID, $pks, Criteria::IN);
  
            $objs = ReviewPeer::doSelect($criteria, $con);
        }
        return $objs;
    }

 

    /**
     * Selects a collection of Review objects pre-filled with their
     * Book objects.
     *
     * @return array Array of Review objects.
     * @throws PropelException Any exceptions caught during processing will be
     *         rethrown wrapped into a PropelException.
     */
    public static function doSelectJoinBook(Criteria $c, $con = null)
    {

        // Set the correct dbName if it has not been overridden
        if ($c->getDbName() == Propel::getDefaultDB()) {
            $c->setDbName(self::DATABASE_NAME);
        }

        ReviewPeer::addSelectColumns($c);
        $startcol = self::$numColumns + 1;
        BookPeer::addSelectColumns($c);

            $c->addJoin(ReviewPeer::BOOK_ID, BookPeer::BOOK_ID);
     
        $rs = BasePeer::doSelect($c, $con);
        $results = array();

        while($rs->next()) {
            $omClass = ReviewPeer::getOMClass();
            $cls = Propel::import($omClass);
            $obj1 = new $cls();
            $obj1->hydrate($rs);

            $omClass = BookPeer::getOMClass();
            $cls = Propel::import($omClass);
            $obj2 = new $cls();
            $obj2->hydrate($rs, $startcol);

            $newObject = true;
            foreach($results as $temp_obj1) {
                $temp_obj2 = $temp_obj1->getBook();
                if ($temp_obj2->getPrimaryKey() === $obj2->getPrimaryKey()) {
                    $newObject = false;
                    $temp_obj2->addReview($obj1);
                    break;
                }
            }
            if ($newObject) {
                $obj2->initReviews();
                $obj2->addReview($obj1);
            }
            $results[] = $obj1;
        }
        return $results;
    }
    /**
     * Returns the TableMap related to this peer.  This method is not
     * needed for general use but a specific application could have a need.
     * @return TableMap
     * @throws PropelException Any exceptions caught during processing will be
     *         rethrown wrapped into a PropelException.
     */
    protected static function getTableMap()
    {
        return Propel::getDatabaseMap(self::DATABASE_NAME)->getTable(self::TABLE_NAME);
    }
    
}

// static code to register the map builder for this Peer with the main Propel class
if (Propel::isInit()) {
    // the MapBuilder classes register themselves with Propel during initialization
    // so we need to load them here.
    try {        
        BaseReviewPeer::getMapBuilder();
    } catch (Exception $e) {
        Propel::logger()->err("Could not initialize Peer: " . $e->getMessage());
    }
} else {
    // even if Propel is not yet initialized, the map builder class can be registered
    // now and then it will be loaded when Propel initializes.
    require_once 'bookstore/map/ReviewMapBuilder.php';
    Propel::registerMapBuilder(ReviewMapBuilder::CLASS_NAME);
}