<?php

/* Reminder: always indent with 4 spaces (no tabs). */

/**
 * PHPARCH - Contact Manager
 *
 * @author Tony Bibbs <tony@geeklog.net>
 * @copyright 2005
 * @version $Id:$
 *
 */

/**
 * Abstract class that knows how to handle active user sessions
 */
require_once 'BaseViewFlexyUser.php';

/**
 * Contact model object
 */
require_once 'PHPARCH/Contact.php';

/**
 * Allows an administrator to maintain all look up values stored in the list_item table.
 *
 * @author Tony Bibbs <tony@geeklog.net>
 *
 */
class PHPArch_HomeView extends PHPARCH_BaseViewFlexyUser {
    /**
     * Holds the contacts for the current user (this is used by flexy)
     * @var array
     * @access public
     */
    public $contacts = array();
    
    /**
     * Shows the login page
     *
     * If we don't have a user object, we show the login page.  Otherwise we forward  the user on
     * to the user home page
     *
     * @author Tony Bibbs <tony@geeklog.net>
     * @access public
     * 
     */
    function processView()
    {
        $this->getMessages();
        
        // Get the contacts in alpha order.  NOTE: you can do this by simply calling 
        // $this->user->getContacts() but you can't really specify a sort order so instead of 
        // using the Criterial class we'll use a named query.
        $dao = PHPARCH_DAO::singleton();
        $this->contacts = $dao->find('getUserContactsInAlphaOrder', array($this->user->getAccountId()));
        
        // Now show the page.
        $this->setPageTitle(sprintf('PHPARCH - Contacts For %s %s', $this->user->getFirstName(), 
            $this->user->getLastName()));
        $this->showHeader(true);
        $this->flexyHandle->compile('List.thtml');
        $this->flexyHandle->outputObject($this);
        $this->showFooter();
    }
    
    public function hasContacts()
    {
        return count($this->contacts);
    }
}

?>